local hyperColors = {SKINCOLOR_S3HYPER1,SKINCOLOR_S3HYPER2,SKINCOLOR_S3HYPER3,SKINCOLOR_S3HYPER4,SKINCOLOR_S3HYPER5,SKINCOLOR_S3HYPER6}
local superEmeralds = 0
local byeEmeralds = 0

COM_AddCommand("getallsuperemeralds", function(player)
	if cv_s3hyper.value == 1 then
		if All7Emeralds(emeralds) then
			print("You now have all 7 Super Emeralds")
			superEmeralds = 7
		else
			print("You need all 7 Chaos Emeralds")
		end
	else
		print("You need to turn on Hyper Sonic")
	end
end, COM_ADMIN)

addHook("MobjThinker", function(mo)
	if All7Emeralds(emeralds) and cv_s3hyper.value == 1 then
		mo.colorized = true
		mo.color = hyperColors[leveltime%12/2+1]
	else
		mo.colorized = false
	end
end, MT_TOKEN)

addHook("TouchSpecial", function(token, mo)
	if All7Emeralds(emeralds) and mo.skin == "s3sonic" then
		if (cv_s3hyper.value == 1 and superEmeralds != 7) then
			mo.player.s3holdingtokens = min($+1,7)
			S_StartSound(mo, sfx_s3kb3)
			P_KillMobj(token,mo,mo)
			CONS_Printf(mo.player, "You Got an Emerald Token! Bring it to the end of the level to Gain a Super Emerald.")
			
			for others in players.iterate do
				if others != mo.player then
					CONS_Printf(others, mo.player.name.." Got an Emerald Tokens.")
				end
			end
			
			if not byeEmeralds then
				local ce
				byeEmeralds = 1
				S_StartSound(mo, sfx_s3kb8)
				for i=1,7 do
					ce = P_SpawnMobjFromMobj(mo,0,0,0,MT_EMERALD1+i-1)
					ce.fuse = 350
					ce.scale = mo.scale
					ce.angle = mo.angle+(ANG30+ANG10)*i
					ce.flags = MF_NOCLIPHEIGHT|MF_NOCLIP|MF_NOGRAVITY|MF_MISSILE
					P_InstaThrust(ce,ce.angle,10*ce.scale)
					P_SetObjectMomZ(ce,15*ce.scale,false)
				end
			end
			
		else
			mo.player.rings = min($+50,9999)
			S_StartSound(mo, sfx_s3kb3)
			P_KillMobj(token,mo,mo)
		end
		return true
	end
end, MT_TOKEN)

local function s3superemeralds(v)
	if superEmeralds and consoleplayer.mo.skin == "s3sonic" then
		if netgame then
			for i=1,superEmeralds do
				v.drawScaled((17*i-5)*FRACUNIT,15*FRACUNIT,FRACUNIT,v.cachePatch("SEMP"..i),V_PERPLAYER)
			end
		else
			for i=1,superEmeralds do
				v.drawScaled(160*FRACUNIT,100*FRACUNIT,FRACUNIT,v.cachePatch("SUEM"..i),V_PERPLAYER)
			end
		end
	end
end
hud.add(s3superemeralds, "scores")

addHook("AbilitySpecial", function(player)
    if (player.mo and player.valid) and (player.mo.skin == "s3sonic")
	if (cv_s3hyper.value == 1 and superEmeralds != 0 and superEmeralds != 7) or byeEmeralds == 1 then return end
        if not player.powers[pw_super] and not player.powers[pw_invulnerability] and not player.powers[pw_flashing] and All7Emeralds(emeralds) and (player.rings >= 50) and (player.powers[pw_shield] == SH_NONE or player.powers[pw_shield] == SH_FIREFLOWER)
			P_DoSuperTransformation(player)
			player.charflags = $|SF_SUPER
			return false
        end
    end
end)

addHook("PlayerThink", function(player)
	if superEmeralds then
		if byeEmeralds != 2 then
			byeEmeralds = 2
		end
		if (cv_s3hyper.value == 0) or gametype != GT_COOP or not All7Emeralds(emeralds) then
			superEmeralds = 0
		end
	end
	
	if byeEmeralds != 0 then
		if consoleplayer.mo.skin == "s3sonic" then
			hud.disable("coopemeralds")
		else
			hud.enable("coopemeralds")
		end
		if (cv_s3hyper.value == 0) or gametype != GT_COOP or not All7Emeralds(emeralds) then
			hud.enable("coopemeralds")
			byeEmeralds = 0
		end
	end
	
	if player.s3holdingtokens then
		/*if player.playerstate == PST_DEAD then
			S_StartSound(player.mo, sfx_s3k66)
			P_FlashPal(player, 1, 10)
			CONS_Printf(player, "You lost your Emerald Tokens.")
			player.s3holdingtokens = 0
		end*/
		if (cv_s3hyper.value == 0) or superEmeralds == 7 or gametype != GT_COOP or not All7Emeralds(emeralds) then
			player.s3holdingtokens = 0
		end
	end
		
	if player.mo and player.valid and player.mo.skin == "s3sonic" then
		
		player.s3holdingtokens = $ or 0
		
		if (cv_s3hyper.value == 1 and superEmeralds != 0 and superEmeralds != 7) or byeEmeralds == 1 then
			player.charflags = $ & ~SF_SUPER
		end
		
		if cv_s3hyper.value == 1 and superEmeralds == 7 then
			player.s3hyper = 1
		else
			player.s3hyper = 0
		end
		
		if player.s3holdingtokens and player.exiting then
			if player.s3holdingtokens == 1 then
				CONS_Printf(player, "You got a Super Emerald!")
				
				for others in players.iterate do
					if others != player then
						CONS_Printf(others, player.name.." got a Super Emerald!")
					end
				end
			
			else
				CONS_Printf(player, "You got " ..player.s3holdingtokens.. " Super Emeralds!")
				
				for others in players.iterate do
					if others != player then
						CONS_Printf(others, player.name.." got " ..player.s3holdingtokens.. " Super Emeralds!")
					end
				end
			
			end
			superEmeralds = min(7,$+player.s3holdingtokens)
			player.s3holdingtokens = 0
			S_StartSound(player.mo, sfx_s3k9c)
			P_FlashPal(player, 1, 10)
		end
		
		if player.s3hyper == 1 and player.powers[pw_super] then
			player.powers[pw_underwater] = 0
			player.powers[pw_spacetime] = 0
			if player.mo.momx or player.mo.momy or player.mo.momz or player.s3fakemomx or player.s3fakemomy then
				local ht1 = P_SpawnGhostMobj(player.mo)
				ht1.fuse = 2
				ht1.s3hyperghost = 1
			end
			
			local hs
			for i=1,4 do
				if leveltime%8+1 == i*2 then
					hs = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_SUPERSPARK)
					if i%2 == 1 then
						hs.angle = player.mo.angle-ANGLE_45+ANGLE_270*i
					else
						hs.angle = player.mo.angle-ANGLE_45+ANGLE_90*i
					end
					hs.s3hyperghost = 1
					hs.target = player.mo
					hs.fuse = 8
					hs.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
				end
			end
		end
		
		player.s3lastx = player.mo.x
		player.s3lasty = player.mo.y
		
	end	
end)

addHook("MobjDeath", function(mo,inflictor,source,dmg,dmgtype)
	if mo.player and mo.skin == "s3sonic" and mo.player.s3holdingtokens then
		mo.player.s3holdingtokens = 0
		S_StartSound(mo, sfx_s3k66)
		P_FlashPal(mo.player, 1, 10)
		CONS_Printf(mo.player, "You lost your Emerald Tokens.")
		
		for others in players.iterate do
			if others != mo.player then
				CONS_Printf(others, mo.player.name.." lost their Emerald Tokens.")
			end
		end
	end
end,MT_PLAYER)

addHook("MobjDamage", function(mo,inflictor,source,dmg,dmgtype)
	if mo.player and mo.skin == "s3sonic" and mo.player.s3holdingtokens and not (mo.player.rings == 0 and mo.player.powers[pw_shield] == SH_NONE) and not (dmgtype == DMG_INSTAKILL) then
		mo.player.s3holdingtokens = $-1
		S_StartSound(mo, sfx_s3k66)
		P_FlashPal(mo.player, 1, 10)
		CONS_Printf(mo.player, "You lost an Emerald Token.")
		
		for others in players.iterate do
			if others != mo.player then
				CONS_Printf(others, mo.player.name.." lost an Emerald Token.")
			end
		end
	end
end,MT_PLAYER)

addHook("AbilitySpecial", function(player)
    if (player.mo and player.valid) and (player.mo.skin == "s3sonic") and (player.s3hyper == 1)
        if player.powers[pw_super] and not (player.pflags & PF_THOKKED)
        and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
            P_NukeEnemies(player.mo, player.mo, 1536*FRACUNIT)
            S_StartSound(player.mo, sfx_zoom)
            P_FlashPal(player, 1, 4)
            player.pflags = $|PF_THOKKED
			
			if player.cmd.buttons & BT_SPIN then
				P_InstaThrust(player.mo,0,0)
				if (player.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(player.mo, -15*player.mo.scale, false)
				else
					P_SetObjectMomZ(player.mo, -30*player.mo.scale, false)
				end
			else
				if P_GetPlayerControlDirection(player) != 0 then
					player.drawangle = player.mo.angle
					P_SetObjectMomZ(player.mo, 0)
					if (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 40*player.mo.scale)
					else
						P_InstaThrust(player.mo, player.mo.angle, 80*player.mo.scale)
					end
				else
					P_InstaThrust(player.mo,0,0)
					player.pflags = $|PF_STARTJUMP
					if (player.mo.eflags & MFE_UNDERWATER)
						P_SetObjectMomZ(player.mo, 15*player.mo.scale, false)
					else
						P_SetObjectMomZ(player.mo, 30*player.mo.scale, false)
					end
				end
			end
				
        end
    end
end)

--fuck this shit bro i hope it doesnt work like what is this garbage
addHook("PostThinkFrame", do
	for player in players.iterate do
		if player.mo and player.valid and player.mo.skin == "s3sonic" then
			player.s3fakemomx = (player.mo.x - player.s3lastx)
			player.s3fakemomy = (player.mo.y - player.s3lasty)
		end
	end
end)
--garbage ends here i hope it doesnt work
--this garbage kinda works and i hate it cus it only kinda works

addHook("MobjThinker", function(spark)
	if spark.s3hyperghost and spark.target and spark.target.player.powers[pw_super] then
		spark.angle = $+ANG20+ANG1*2
		P_InstaThrust(spark,spark.angle,15*spark.target.scale)
		if spark.target.player.powers[pw_carry] then
			if (spark.target.player.powers[pw_carry] == CR_MINECART) then
				P_MoveOrigin(spark, spark.x + spark.target.tracer.momx, spark.y + spark.target.tracer.momy, spark.target.z)
			else
				P_MoveOrigin(spark,spark.x+spark.target.player.s3fakemomx,spark.y+spark.target.player.s3fakemomy,spark.target.z)
			end
		else
			P_MoveOrigin(spark,spark.x+spark.target.momx,spark.y+spark.target.momy,spark.target.z)
		end
		
		/*if (spark.target.player.powers[pw_carry] == CR_MINECART) or (spark.target.player.powers[pw_carry] == CR_MACESPIN)
            P_MoveOrigin(spark, spark.x + spark.target.tracer.momx, spark.y + spark.target.tracer.momy, spark.target.z)
        elseif (spark.target.player.powers[pw_carry] == CR_DUSTDEVIL)
            P_MoveOrigin(spark, spark.x, spark.y, spark.target.z)
        else
            if not (spark.target.player.powers[pw_carry] == CR_MACESPIN) then
				P_MoveOrigin(spark,spark.x+spark.target.momx,spark.y+spark.target.momy,spark.target.z)
			end
        end*/
		
	end
end, MT_SUPERSPARK)

addHook("MobjThinker", function(ghost)
	if ghost.skin == "s3sonic" and ghost.target and ghost.target.player.powers[pw_super] then
		if ghost.s3hyperghost then
			ghost.dispoffset = -1
			if ghost.sprite2 == FF_SPR2SUPER|SPR2_FALL then
				ghost.eflags = $|MFE_FORCESUPER
				ghost.state = ghost.target.state
				ghost.frame = ghost.target.frame|TR_TRANS30
			else
				ghost.frame = ghost.target.frame|TR_TRANS30
			end
		else
			ghost.flags2 = $|MF2_DONTDRAW
		end
	end
end, MT_GHOST)